<script>
    export let plot_element;
    export let data;
    export let xScale;
    export let yScale;
    import * as d3 from "d3";

    // Default settings
    $: ymaxrow = yScale.domain()[1] - 0.5;
    // console.log(data.datalist);
    let colors = {};
    let row = {};
    if (plot_element.data.dataset.startsWith("gnss_alerts_icao")) {
        colors = {
            GNSS_SEV: "red",
            GNSS_MOD: "blue",
        };
        row = {
            GNSS_SEV: 0,
            GNSS_MOD: 1,
        };
    } else if (plot_element.data.dataset.startsWith("hf_alerts_icao")) {
        colors = {
            HF_SEV: "red",
            HF_MOD: "blue",
        };
        row = {
            HF_SEV: 0,
            HF_MOD: 1,
        };
    } else if (plot_element.data.dataset.startsWith("rad_alerts_icao")) {
        colors = {
            RAD_SEV: "red",
            RAD_MOD: "blue",
        };
        row = {
            RAD_SEV: 0,
            RAD_MOD: 1,
        };
    } else {
        console.log("This type is not yet implemented");
    }

    const show_notification = function (e) {
        alert(e.srcElement.attributes["data-message"].value);
    };
</script>

{#each data.datalist as d}
    {console.log(d)}
    <g on:click={show_notification}>
        <title>Notification: {d.message_code}</title>
        <circle
            cx={xScale(new Date(d.time))}
            cy={yScale(ymaxrow - row[d.message_code])}
            r="5px"
            fill={colors[d.message_code]}
            data-message="{d.message_code}: {d.message}" />
        {#if d.begin_time.length > 0}
            <line
                x1={xScale(new Date(d.begin_time))}
                x2={xScale(new Date(d.time))}
                y1={yScale(ymaxrow - row[d.message_code])}
                y2={yScale(ymaxrow - row[d.message_code])}
                stroke-width="2px"
                stroke={colors[d.message_code]}
                data-message="{d.message_code}: {d.message}" />
        {/if}
        {#if d.begin_time.length > 0 && d.end_time.length > 0}
            <line
                x1={xScale(new Date(d.begin_time))}
                x2={xScale(new Date(d.end_time))}
                y1={yScale(ymaxrow - row[d.message_code])}
                y2={yScale(ymaxrow - row[d.message_code])}
                stroke-width="6px"
                stroke={colors[d.message_code]}
                data-message="{d.message_code}: {d.message}" />
        {/if}
    </g>
{/each}

<style>
    circle {
        cursor: pointer;
    }
    line {
        cursor: pointer;
    }
</style>
